class Point:
    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y

    def __add__(self, other):
        return Point(self.x + other.x, self.y + other.y)

    def __mul__(self, other):
        if isinstance(other, Point):
            return Point(self.x * other.x, self.y * other.y)
        elif isinstance(other, int):
            return Point(self.x * other, self.y * other)

    def __str__(self):
        return f"({self.x}, {self.y})"

    def copy(self):
        return Point(self.x, self.y)


k, n = map(int, input().split())

directions = {'N': Point(0, 1), 'S': Point(0, -1), 'W': Point(-1, 0), 'E': Point(0, 1)}
blacklist = set()
pos = Point(0, 0)

for y in range(k):
    for x in range(k):
        blacklist.add(Point(x, y))

for _ in range(n):
    d, a = input().split()
    a = int(a)
    motion = directions[d] * a
    pos += motion
    for y in range(k):
        for x in range(k):
            for m in range(1, a + 1):
                mo = directions[d] * m
                blacklist.add(Point(x, y) + mo)

print(len(blacklist))
