class Point:
    def __init__(self, x=0, y=0):
        self.x = x
        self.y = y
        self.hash = None

    def __add__(self, other):
        return Point(self.x + other.x, self.y + other.y)

    def __mul__(self, other):
        if isinstance(other, Point):
            return Point(self.x * other.x, self.y * other.y)
        elif isinstance(other, int):
            return Point(self.x * other, self.y * other)


k, n = map(int, input().split())

directions = {'N': Point(0, 1), 'S': Point(0, -1), 'W': Point(-1, 0), 'E': Point(1, 0)}
blacklist = set()
pos = Point(0, 0)

for y in range(k):
    for x in range(k):
        blacklist.add((x, y))

for _ in range(n):
    d, a = input().split()
    a = int(a)
    motion = directions[d] * a
    for y in range(k):
        for x in range(k):
            for m in range(1, a + 1):
                mo = directions[d] * m
                blacklist.add((x + mo.x + pos.x, y + mo.y + pos.y))
    pos += motion

print(len(blacklist))
